Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/Converter.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/Converter.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/Converter.java	(revision 61441)
@@ -12,6 +12,7 @@
 import org.json.JSONArray;
 import org.json.JSONException;
 import org.json.JSONObject;
+import org.springframework.stereotype.Component;
 
 import java.io.BufferedReader;
 import java.io.IOException;
@@ -21,6 +22,7 @@
 import java.text.SimpleDateFormat;
 import java.util.*;
 
+@Component
 public class Converter {
 
     private static final Logger LOGGER = Logger.getLogger(Converter.class);
@@ -28,7 +30,7 @@
     public static Repository jsonToRepositoryObject(JSONObject repositoryObject) throws JSONException {
 
         Repository repository = new Repository();
-        
+
         JSONObject datasource = repositoryObject.getJSONObject("datasource");
 
         //if( datasource.equals(null))
@@ -37,51 +39,51 @@
         repository.setId(datasource.get("id").toString());
         repository.setOfficialName(datasource.get("officialname").toString());
 
-        repository.setEnglishName( datasource.get("englishname").toString());
-        if(repository.getEnglishName().equals("null"))
+        repository.setEnglishName(datasource.get("englishname").toString());
+        if (repository.getEnglishName().equals("null"))
             repository.setEnglishName("");
 
         repository.setWebsiteUrl(datasource.get("websiteurl").toString());
-        if(repository.getWebsiteUrl().equals("null"))
+        if (repository.getWebsiteUrl().equals("null"))
             repository.setWebsiteUrl("");
 
         repository.setLogoUrl(datasource.get("logourl").toString());
-        if(repository.getLogoUrl().equals("null"))
+        if (repository.getLogoUrl().equals("null"))
             repository.setLogoUrl("");
 
         repository.setContactEmail(datasource.get("contactemail").toString());
-        if(repository.getContactEmail().equals("null"))
+        if (repository.getContactEmail().equals("null"))
             repository.setContactEmail("");
 
 
-        repository.setLatitude( toDouble(datasource.get("latitude").toString()));
+        repository.setLatitude(toDouble(datasource.get("latitude").toString()));
         repository.setLongitude(toDouble(datasource.get("longitude").toString()));
         Double timezone = toDouble(datasource.get("timezone").toString());
-        repository.setTimezone(timezone!=null?timezone:0.0);
+        repository.setTimezone(timezone != null ? timezone : 0.0);
         repository.setNamespacePrefix(datasource.get("namespaceprefix").toString());
         repository.setOdLanguages(datasource.get("languages").toString());
-        repository.setDateOfValidation(convertStringToDate( datasource.get("dateofvalidation").toString()));
+        repository.setDateOfValidation(convertStringToDate(datasource.get("dateofvalidation").toString()));
 
         /*  typology -> platform
          *  datasource class -> typology */
         repository.setTypology(datasource.get("platform").toString());
-        if(repository.getTypology().equals("null"))
+        if (repository.getTypology().equals("null"))
             repository.setTypology("");
         repository.setDatasourceClass(datasource.get("typology").toString());
 
-        repository.setDateOfCollection(convertStringToDate( datasource.get("dateofcollection").toString()));
+        repository.setDateOfCollection(convertStringToDate(datasource.get("dateofcollection").toString()));
         repository.setActivationId(datasource.get("activationId").toString());
 
         repository.setDescription(datasource.get("description").toString());
-        if(repository.getDescription().equals("null"))
+        if (repository.getDescription().equals("null"))
             repository.setDescription("");
 
         repository.setIssn(datasource.get("issn").toString());
         repository.setLissn(datasource.get("lissn").toString());
-        if(repository.getLissn().equals("null"))
+        if (repository.getLissn().equals("null"))
             repository.setLissn("");
         repository.setEissn(datasource.get("eissn").toString());
-        if(repository.getEissn().equals("null"))
+        if (repository.getEissn().equals("null"))
             repository.setEissn("");
         repository.setRegisteredBy(datasource.get("registeredby").toString());
 
@@ -94,8 +96,8 @@
         repository.setCollectedFrom(datasource.get("collectedfrom").toString());
 
         //TODO change organization to list
-        JSONArray organizations = ((JSONArray)datasource.get("organizations"));
-        if(organizations.length() != 0) {
+        JSONArray organizations = ((JSONArray) datasource.get("organizations"));
+        if (organizations.length() != 0) {
             repository.setOrganization(((JSONArray) datasource.get("organizations")).getJSONObject(0).get("legalname").toString());
             String countryCode = ((JSONArray) datasource.get("organizations")).getJSONObject(0).get("country").toString();
             repository.setCountryCode(countryCode);
@@ -106,9 +108,9 @@
         return repository;
     }
 
-    public static Date convertStringToDate(String date){
+    public static Date convertStringToDate(String date) {
 
-        if(Objects.equals(date, "null"))
+        if (Objects.equals(date, "null"))
             return null;
 
         SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
@@ -115,14 +117,14 @@
         try {
             return formatter.parse(date);
         } catch (ParseException e) {
-           LOGGER.error(e);
+            LOGGER.error(e);
         }
         return null;
     }
 
-    public static String convertDateToString(Date date){
+    public static String convertDateToString(Date date) {
 
-        if(Objects.equals(date, null))
+        if (Objects.equals(date, null))
             return null;
 
         SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
@@ -129,8 +131,8 @@
         return formatter.format(date);
     }
 
-    public static Double toDouble(String number){
-        if(Objects.equals(number, "null"))
+    public static Double toDouble(String number) {
+        if (Objects.equals(number, "null"))
             return 0.0;
         else
             return Double.valueOf(number);
@@ -140,12 +142,12 @@
 
         List<RepositorySnippet> resultSet = new ArrayList<>();
         JSONArray rs = json.getJSONArray("datasourceInfo");
-        for(int i=0;i<rs.length();i++)
-            resultSet.add(jsonToRepositorySnippetObject( rs.getJSONObject(i)) );
+        for (int i = 0; i < rs.length(); i++)
+            resultSet.add(jsonToRepositorySnippetObject(rs.getJSONObject(i)));
         return resultSet;
     }
 
-    private static RepositorySnippet jsonToRepositorySnippetObject(JSONObject repositorySnippetObject) throws JSONException {
+    public static RepositorySnippet jsonToRepositorySnippetObject(JSONObject repositorySnippetObject) throws JSONException {
 
 
         RepositorySnippet repositorySnippet = new RepositorySnippet();
@@ -156,16 +158,16 @@
         repositorySnippet.setId(repositorySnippetObject.get("id").toString());
         repositorySnippet.setOfficialname(repositorySnippetObject.get("officialname").toString());
 
-        repositorySnippet.setEnglishname( repositorySnippetObject.get("englishname").toString());
-        if(repositorySnippet.getEnglishname().equals("null"))
+        repositorySnippet.setEnglishname(repositorySnippetObject.get("englishname").toString());
+        if (repositorySnippet.getEnglishname().equals("null"))
             repositorySnippet.setEnglishname("");
 
         repositorySnippet.setWebsiteurl(repositorySnippetObject.get("websiteurl").toString());
-        if(repositorySnippet.getWebsiteurl().equals("null"))
+        if (repositorySnippet.getWebsiteurl().equals("null"))
             repositorySnippet.setWebsiteurl("");
 
         repositorySnippet.setRegisteredby(repositorySnippetObject.get("registeredby").toString());
-        if(repositorySnippet.getRegisteredby().equals("null"))
+        if (repositorySnippet.getRegisteredby().equals("null"))
             repositorySnippet.setRegisteredby("");
         return repositorySnippet;
 
@@ -175,8 +177,8 @@
 
         List<Repository> resultSet = new ArrayList<>();
         JSONArray rs = json.getJSONArray("datasourceInfo");
-        for(int i=0;i<rs.length();i++)
-            resultSet.add(jsonToRepositoryObject( rs.getJSONObject(i)) );
+        for (int i = 0; i < rs.length(); i++)
+            resultSet.add(jsonToRepositoryObject(rs.getJSONObject(i)));
         return resultSet;
     }
 
@@ -184,8 +186,8 @@
 
         List<RepositoryInterface> resultSet = new ArrayList<>();
         JSONArray rs = json.getJSONArray("api");
-        for(int i=0;i<rs.length();i++)
-            resultSet.add(jsonToRepositoryInterfaceObject( rs.getJSONObject(i)) );
+        for (int i = 0; i < rs.length(); i++)
+            resultSet.add(jsonToRepositoryInterfaceObject(rs.getJSONObject(i)));
         return resultSet;
     }
 
@@ -204,7 +206,7 @@
         repositoryInterface.setRemovable(Boolean.parseBoolean(repositoryInterfaceObject.get("removable").toString()));
 
 
-       // repositoryInterface.setMetadataIdentifierPath(repositoryInterfaceObject.get("metadataIdentifierPath").toString());
+        // repositoryInterface.setMetadataIdentifierPath(repositoryInterfaceObject.get("metadataIdentifierPath").toString());
         repositoryInterface.setDesiredCompatibilityLevel(repositoryInterfaceObject.get("compatibility").toString());
         //repositoryInterface.setActive(Boolean.parseBoolean(repositoryInterfaceObject.get("active").toString()));
 
@@ -215,8 +217,8 @@
         ObjectMapper mapper = new ObjectMapper();
         JSONArray apiparams = repositoryInterfaceObject.getJSONArray("apiParams");
 
-        for(int i=0;i<apiparams.length();i++)
-            accessParams.put(apiparams.getJSONObject(i).getString("param"),apiparams.getJSONObject(i).getString("value"));
+        for (int i = 0; i < apiparams.length(); i++)
+            accessParams.put(apiparams.getJSONObject(i).getString("param"), apiparams.getJSONObject(i).getString("value"));
 
         repositoryInterface.setAccessParams(accessParams);
 
@@ -225,58 +227,58 @@
 
     public static String repositoryObjectToJson(Repository repository) throws JSONException, JsonProcessingException {
 
-        HashMap<String,Object> repositoryMap = new HashMap<>();
+        HashMap<String, Object> repositoryMap = new HashMap<>();
         ObjectMapper mapper = new ObjectMapper();
 
-        repositoryMap.put("id",repository.getId());
-        repositoryMap.put("openaireId",getOpenaireId(repository.getId()));
-        repositoryMap.put("officialname",repository.getOfficialName());
-        repositoryMap.put("englishname",repository.getEnglishName());
-        repositoryMap.put("websiteurl",repository.getWebsiteUrl());
-        repositoryMap.put("logourl",repository.getLogoUrl());
-        repositoryMap.put("contactemail",repository.getContactEmail());
-        repositoryMap.put("longitude",repository.getLongitude().toString());
-        repositoryMap.put("latitude",repository.getLatitude().toString());
-        repositoryMap.put("timezone",repository.getTimezone());
+        repositoryMap.put("id", repository.getId());
+        repositoryMap.put("openaireId", getOpenaireId(repository.getId()));
+        repositoryMap.put("officialname", repository.getOfficialName());
+        repositoryMap.put("englishname", repository.getEnglishName());
+        repositoryMap.put("websiteurl", repository.getWebsiteUrl());
+        repositoryMap.put("logourl", repository.getLogoUrl());
+        repositoryMap.put("contactemail", repository.getContactEmail());
+        repositoryMap.put("longitude", repository.getLongitude().toString());
+        repositoryMap.put("latitude", repository.getLatitude().toString());
+        repositoryMap.put("timezone", repository.getTimezone());
 
-        repositoryMap.put("namespaceprefix",repository.getNamespacePrefix()!=null?repository.getNamespacePrefix():"");
-        repositoryMap.put("languages",repository.getOdLanguages()!=null?repository.getOdLanguages():"");
+        repositoryMap.put("namespaceprefix", repository.getNamespacePrefix() != null ? repository.getNamespacePrefix() : "");
+        repositoryMap.put("languages", repository.getOdLanguages() != null ? repository.getOdLanguages() : "");
 
-        repositoryMap.put("dateofcollection",repository.getDateOfCollection()!=null?convertDateToString(repository.getDateOfCollection()):"");
+        repositoryMap.put("dateofcollection", repository.getDateOfCollection() != null ? convertDateToString(repository.getDateOfCollection()) : "");
 
         /*
-        * typology -> platform
-        * datasource class -> typology
-        * */
-        repositoryMap.put("typology",repository.getDatasourceClass());
-        repositoryMap.put("platform",repository.getTypology());
+         * typology -> platform
+         * datasource class -> typology
+         * */
+        repositoryMap.put("typology", repository.getDatasourceClass());
+        repositoryMap.put("platform", repository.getTypology());
 
-        repositoryMap.put("dateofvalidation",repository.getDateOfCollection()!=null?convertDateToString(repository.getDateOfCollection()):"");
-        repositoryMap.put("activationId",repository.getActivationId()!=null?repository.getActivationId():"");
+        repositoryMap.put("dateofvalidation", repository.getDateOfCollection() != null ? convertDateToString(repository.getDateOfCollection()) : "");
+        repositoryMap.put("activationId", repository.getActivationId() != null ? repository.getActivationId() : "");
 
-        repositoryMap.put("description",repository.getDescription());
+        repositoryMap.put("description", repository.getDescription());
 
-        repositoryMap.put("eissn",repository.getEissn()!=null?repository.getEissn():"");
-        repositoryMap.put("issn",repository.getIssn()!=null?repository.getIssn():"");
-        repositoryMap.put("lissn",repository.getLissn()!=null?repository.getLissn():"");
+        repositoryMap.put("eissn", repository.getEissn() != null ? repository.getEissn() : "");
+        repositoryMap.put("issn", repository.getIssn() != null ? repository.getIssn() : "");
+        repositoryMap.put("lissn", repository.getLissn() != null ? repository.getLissn() : "");
 
-        repositoryMap.put("registeredby",repository.getRegisteredBy());
+        repositoryMap.put("registeredby", repository.getRegisteredBy());
 
-        repositoryMap.put("aggregator",repository.getAggregator()!=null?repository.getAggregator():"");
-        repositoryMap.put("collectedfrom",repository.getCollectedFrom()!=null?repository.getCollectedFrom():"");
+        repositoryMap.put("aggregator", repository.getAggregator() != null ? repository.getAggregator() : "");
+        repositoryMap.put("collectedfrom", repository.getCollectedFrom() != null ? repository.getCollectedFrom() : "");
 
-        repositoryMap.put("managed",repository.isRegistered());
+        repositoryMap.put("managed", repository.isRegistered());
 
-        Map<String,String> organization = new HashMap<>();
-        organization.put("legalname",repository.getOrganization());
-        organization.put("country",repository.getCountryCode());
-        organization.put("legalshortname","");
-        organization.put("websiteurl","");
-        organization.put("logourl","");
+        Map<String, String> organization = new HashMap<>();
+        organization.put("legalname", repository.getOrganization());
+        organization.put("country", repository.getCountryCode());
+        organization.put("legalshortname", "");
+        organization.put("websiteurl", "");
+        organization.put("logourl", "");
 
         List organizations = new ArrayList();
         organizations.add(organization);
-        repositoryMap.put("organizations",organizations);
+        repositoryMap.put("organizations", organizations);
 
         //TODO check identitites
         //Map<String,String> identity = new HashMap<>();
@@ -293,43 +295,43 @@
             repositoryMap.put("identities", identities);
         }
 
-        repositoryMap.put("subjects","");
+        repositoryMap.put("subjects", "");
 
         return mapper.writeValueAsString(repositoryMap);
     }
 
-    public static String repositoryInterfaceObjectToJson(Repository repository,RepositoryInterface repositoryInterface) throws JSONException {
+    public static String repositoryInterfaceObjectToJson(Repository repository, RepositoryInterface repositoryInterface) throws JSONException {
 
         JSONObject jsonObject = new JSONObject();
 
-        jsonObject.put("id",repositoryInterface.getId());
-        jsonObject.put("protocol",repositoryInterface.getAccessProtocol());
-        jsonObject.put("datasource",repository.getId());
-        jsonObject.put("contentdescription",repositoryInterface.getContentDescription());
-        jsonObject.put("typology",repositoryInterface.getTypology());
-        jsonObject.put("compatibility",repositoryInterface.getDesiredCompatibilityLevel());
-        jsonObject.put("compatibilityOverride",repositoryInterface.getDesiredCompatibilityLevel());
+        jsonObject.put("id", repositoryInterface.getId());
+        jsonObject.put("protocol", repositoryInterface.getAccessProtocol());
+        jsonObject.put("datasource", repository.getId());
+        jsonObject.put("contentdescription", repositoryInterface.getContentDescription());
+        jsonObject.put("typology", repositoryInterface.getTypology());
+        jsonObject.put("compatibility", repositoryInterface.getDesiredCompatibilityLevel());
+        jsonObject.put("compatibilityOverride", repositoryInterface.getDesiredCompatibilityLevel());
 
-        jsonObject.put("lastCollectionTotal","");
+        jsonObject.put("lastCollectionTotal", "");
 
-        jsonObject.put("lastCollectionDate",repositoryInterface.getLastCollectionDate());
-        jsonObject.put("lastAggregationTotal","");
-        jsonObject.put("lastAggregationDate","");
-        jsonObject.put("lastDownloadTotal","");
-        jsonObject.put("lastDownloadDate","");
+        jsonObject.put("lastCollectionDate", repositoryInterface.getLastCollectionDate());
+        jsonObject.put("lastAggregationTotal", "");
+        jsonObject.put("lastAggregationDate", "");
+        jsonObject.put("lastDownloadTotal", "");
+        jsonObject.put("lastDownloadDate", "");
 
-        jsonObject.put("baseurl",repositoryInterface.getBaseUrl());
-        jsonObject.put("removable",repositoryInterface.isRemovable());
+        jsonObject.put("baseurl", repositoryInterface.getBaseUrl());
+        jsonObject.put("removable", repositoryInterface.isRemovable());
 
-        
+
         JSONArray apiparams = new JSONArray();
-        for(String param: repositoryInterface.getAccessParams().keySet()){
+        for (String param : repositoryInterface.getAccessParams().keySet()) {
             JSONObject jo = new JSONObject();
-            jo.put("param",param);
-            jo.put("value",repositoryInterface.getAccessParams().get(param));
+            jo.put("param", param);
+            jo.put("value", repositoryInterface.getAccessParams().get(param));
             apiparams.put(jo);
         }
-        jsonObject.put("apiParams",apiparams);
+        jsonObject.put("apiParams", apiparams);
 
 
 //        jsonObject.put("metadataIdentifierPath",repositoryInterface.getMetadataIdentifierPath());
@@ -345,7 +347,7 @@
             //InputStream in = Converter.class.getResourceAsStream("resources/eu/dnetlib/repo/manager/service/utils/"+filename);
             InputStream in = Converter.class.getClass().getResourceAsStream("/eu/**/" + filename);
             BufferedReader br = new BufferedReader(new InputStreamReader(in));
-            while((line = br.readLine()) != null) {
+            while ((line = br.readLine()) != null) {
                 list.add(line.trim());
             }
             br.close();
@@ -375,9 +377,9 @@
         AggregationDetails aggregationDetails = new AggregationDetails();
 
         aggregationDetails.setAggregationStage(aggregationObject.get("aggregationStage").toString());
-        if(aggregationObject.has("collectionMode"))
+        if (aggregationObject.has("collectionMode"))
             aggregationDetails.setCollectionMode(aggregationObject.get("collectionMode").toString());
-        if(aggregationObject.has("indexedVersion"))
+        if (aggregationObject.has("indexedVersion"))
             aggregationDetails.setIndexedVersion(Boolean.parseBoolean(aggregationObject.get("indexedVersion").toString()));
         aggregationDetails.setDate(convertStringToDate(aggregationObject.get("date").toString()));
         aggregationDetails.setNumberOfRecords(Integer.parseInt(aggregationObject.get("numberOfRecords").toString()));
@@ -388,9 +390,9 @@
     public static List<Timezone> toTimezones(List<String> timezones) {
 
         List<Timezone> tmz = new ArrayList<>();
-        for(String t : timezones){
+        for (String t : timezones) {
             String[] s = t.split("\t");
-            tmz.add(new Timezone(s[1],Double.parseDouble(s[0])));
+            tmz.add(new Timezone(s[1], Double.parseDouble(s[0])));
         }
         return tmz;
     }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/JsonUtils.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/JsonUtils.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/utils/JsonUtils.java	(revision 61441)
@@ -0,0 +1,40 @@
+package eu.dnetlib.repo.manager.utils;
+
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+
+public class JsonUtils {
+
+    private JsonUtils() {
+    }
+
+    public JsonObject createResponse(JsonElement response) {
+        JsonObject json = new JsonObject();
+        json.add("response", response);
+        return json;
+    }
+
+    public static JsonObject createResponse(String response) {
+        JsonObject json = new JsonObject();
+        json.addProperty("response", response);
+        return json;
+    }
+
+    public JsonObject createResponse(Number response) {
+        JsonObject json = new JsonObject();
+        json.addProperty("response", response);
+        return json;
+    }
+
+    public static JsonObject createResponse(Boolean response) {
+        JsonObject json = new JsonObject();
+        json.addProperty("response", response);
+        return json;
+    }
+
+    public static JsonObject createResponse(Character response) {
+        JsonObject json = new JsonObject();
+        json.addProperty("response", response);
+        return json;
+    }
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/FrontEndLinkURIAuthenticationSuccessHandler.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/FrontEndLinkURIAuthenticationSuccessHandler.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/FrontEndLinkURIAuthenticationSuccessHandler.java	(revision 61441)
@@ -1,12 +1,12 @@
 package eu.dnetlib.repo.manager.config;
 
-import com.google.gson.Gson;
-import com.google.gson.JsonObject;
+import com.google.gson.JsonParser;
 import org.apache.log4j.Logger;
 import org.mitre.openid.connect.model.OIDCAuthenticationToken;
 import org.springframework.beans.factory.annotation.Value;
 import org.springframework.security.core.Authentication;
 import org.springframework.security.web.authentication.AuthenticationSuccessHandler;
+import org.springframework.session.FindByIndexNameSessionRepository;
 
 import javax.servlet.ServletException;
 import javax.servlet.http.Cookie;
@@ -13,7 +13,10 @@
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
 import java.io.IOException;
-import java.net.URLEncoder;
+import java.util.Base64;
+import java.util.Date;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
 
 public class FrontEndLinkURIAuthenticationSuccessHandler implements AuthenticationSuccessHandler {
 
@@ -22,7 +25,7 @@
     private static final Logger LOGGER = Logger
             .getLogger(FrontEndLinkURIAuthenticationSuccessHandler.class);
 
-    public void init(){
+    public void init() {
         LOGGER.debug("Front end uri : " + frontEndURI);
     }
 
@@ -32,53 +35,22 @@
 
     @Override
     public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {
-
         OIDCAuthenticationToken authOIDC = (OIDCAuthenticationToken) authentication;
-        JsonObject userInfo = new JsonObject();
+        request.getSession().setAttribute(FindByIndexNameSessionRepository.PRINCIPAL_NAME_INDEX_NAME, authOIDC.getUserInfo().getEmail());
 
-        if (authOIDC.getUserInfo().getSub() == null)
-            userInfo.addProperty("sub", "");
-        else
-            userInfo.addProperty("sub", URLEncoder.encode(authOIDC.getUserInfo().getSub(), "UTF-8"));
-
-
-        if(authOIDC.getUserInfo().getName() != null)
-            userInfo.addProperty("fullname", URLEncoder.encode(authOIDC.getUserInfo().getName(), "UTF-8"));
-
-        if (authOIDC.getUserInfo().getGivenName() == null)
-            userInfo.addProperty("firstname", "");
-        else
-            userInfo.addProperty("firstname", URLEncoder.encode(authOIDC.getUserInfo().getGivenName(), "UTF-8") + "");
-
-        if (authOIDC.getUserInfo().getFamilyName() == null)
-            userInfo.addProperty("lastname",  "");
-        else
-            userInfo.addProperty("lastname", URLEncoder.encode(authOIDC.getUserInfo().getFamilyName(), "UTF-8") + "");
-
-        userInfo.addProperty("email", authOIDC.getUserInfo().getEmail() + "");
-        if (authOIDC.getUserInfo().getSource().getAsJsonArray("edu_person_entitlements") == null)
-            userInfo.addProperty("role",  "");
-        else
-            userInfo.addProperty("role", URLEncoder.encode(authOIDC.getUserInfo()
-                    .getSource().getAsJsonArray("edu_person_entitlements").toString(), "UTF-8") + "");
-
-
-        Cookie openAIREUser = new Cookie("openAIREUser", new Gson().toJson(userInfo) );
-        openAIREUser.setMaxAge(14400);
-        openAIREUser.setPath("/");
-        if(aai_mode.equalsIgnoreCase("production") || aai_mode.equalsIgnoreCase("beta"))
-            openAIREUser .setDomain(".openaire.eu");
-//        openAIREUser.setDomain(".athenarc.gr");
-        response.addCookie(openAIREUser);
-
-
         Cookie accessToken = new Cookie("AccessToken", authOIDC.getAccessTokenValue());
-        accessToken.setMaxAge(14400);
-        if(aai_mode.equalsIgnoreCase("production") || aai_mode.equalsIgnoreCase("beta"))
+        String regex = "^([A-Za-z0-9-_=]+)\\.([A-Za-z0-9-_=]+)\\.?([A-Za-z0-9-_.+=]*)$";
+        Matcher matcher = Pattern.compile(regex).matcher(authOIDC.getAccessTokenValue());
+        if (matcher.find()) {
+            long exp = new JsonParser().parse(new String(Base64.getDecoder().decode(matcher.group(2)))).getAsJsonObject().get("exp").getAsLong();
+            accessToken.setMaxAge((int) (exp - (new Date().getTime() / 1000)));
+        } else {
+            accessToken.setMaxAge(3600);
+        }
+        if (aai_mode.equalsIgnoreCase("production") || aai_mode.equalsIgnoreCase("beta"))
             accessToken.setDomain(".openaire.eu");
         accessToken.setPath("/");
 
-//        accessToken.setDomain(".athenarc.gr");
         response.addCookie(accessToken);
         response.sendRedirect(frontEndURI);
     }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/OpenAIREAuthoritiesMapper.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/OpenAIREAuthoritiesMapper.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/OpenAIREAuthoritiesMapper.java	(revision 61441)
@@ -0,0 +1,48 @@
+package eu.dnetlib.repo.manager.config;
+
+import com.google.gson.JsonArray;
+import com.nimbusds.jwt.JWT;
+import eu.dnetlib.repo.manager.service.security.AuthoritiesMapper;
+import org.apache.log4j.Logger;
+import org.mitre.openid.connect.client.OIDCAuthoritiesMapper;
+import org.mitre.openid.connect.model.UserInfo;
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.context.annotation.ComponentScan;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.stereotype.Component;
+
+import java.util.*;
+
+@ComponentScan
+@Component
+public class OpenAIREAuthoritiesMapper implements OIDCAuthoritiesMapper {
+
+    private static final Logger logger = Logger.getLogger(OpenAIREAuthoritiesMapper.class);
+
+    @Value("${services.repo-manager.adminEmail}")
+    String adminEmail;
+
+    @Override
+    public Collection<? extends GrantedAuthority> mapAuthorities(JWT jwtToken, UserInfo userInfo) {
+        JsonArray entitlements = null;
+        Set<GrantedAuthority> authorities = new HashSet<>();
+        if (userInfo != null && userInfo.getSource() != null) {
+            if (userInfo.getSource().getAsJsonArray("edu_person_entitlements") != null) {
+                entitlements = userInfo.getSource().getAsJsonArray("edu_person_entitlements");
+            } else if (userInfo.getSource().getAsJsonArray("eduperson_entitlement") != null) {
+                entitlements = userInfo.getSource().getAsJsonArray("eduperson_entitlement");
+            }
+            logger.debug("user info: " + userInfo + "\nentitlements: " + entitlements);
+
+            // FIXME: delete this if statement when super administrators are set
+            if (userInfo.getEmail() != null && userInfo.getEmail().equals(adminEmail)) {
+                authorities.add(new SimpleGrantedAuthority("SUPER_ADMINISTRATOR"));
+            }
+
+            authorities.addAll(AuthoritiesMapper.map(entitlements));
+        }
+        return authorities;
+    }
+}
+
